

;****************************************
; SETUP THE INTERRUPTS...
;****************************************

; disable ints before calling				
; hl = interrupt routine address
; ints enabled on return

;SetupInts:	ld      a,OP_JP				; jp opcode
;			ld      (INTVECTOR),a
;			ld      (INTVECTOR+1),hl

;			ld		bc,INTVECTOR / 0x100
;			ld		hl,INTTABLE
;			ld		a,h
;			ld		i,a
;			im		2

;IntSet:		ld		(hl),c				; setup 257 byte vector table
;			inc		hl
;			djnz	IntSet
;			ld		(hl),c
;			ei
;			ret

;****************************************
; WORK THE INTERRUPTS...
;****************************************

INTERRUPCION:	push	af

			ld		a,0x80				; flag the interrupt
			ld		r,a

      ; Contador del sonido
			ld		a,(SpeedFlag)		; increase timer
			inc		a
			ld		(SpeedFlag),a

      ; Mi contador
      ld    a,(_VG_TIMER)
      inc   a
      ld    (_VG_TIMER), a

			pop		af
			;-ei
			;reti
			ret

;****************************************
; START SOUND FX...
;****************************************

GoFX:
;			ex		af,af
;			ld		a,(FXNumber)		; sound already playing - priority?
;			or		a
;			ret		nz
;			ex		af,af

GoFXForce:	ld		(FXNumber),a		; current FX number
			add		a,a
			add		a,FXTable-2 & 0xff
			ld		l,a
			ld		h,FXTable / 0x100
			ld		a,(hl)
			inc		l
			ld		h,(hl)
			ld		l,a
			ld		(FXPointer),hl		; current FX data
			ret

;****************************************
; WAIT FOR FLYBACK...
;****************************************

WaitVBlank:	xor		a
			ld		r,a
			;ei

			ld		a,(FXNumber)
			or		a
			jr		nz,Beeper

WaitInt:	ld		a,r
			jp		p,WaitInt
			;di
			ret

;****************************************
; IN GAME BEEPER ROUTINES...
;****************************************

Beeper:		ld		hl,(FXPointer)		; table pointer

			ld		a,(hl)				; frequency + code (1 frame info only)
			inc		hl
			cp		LASTFXCODE			; new control code?
			jr		nc,PlayFX0

			add		a,a
			jr		nz,PlayFX
			ld		(FXNumber),a		; no more sound
			jr		WaitInt

PlayFX:		push	hl
			add		a,FXRout & 0xff
			ld		l,a
			ld		h,FXRout / 0x100
			ld		a,(hl)
			inc		l
			ld		h,(hl)
			ld		l,a
			ld		(FXCode),hl			; change current beeper routine
			pop		hl
			ld		a,(hl)

PlayFX0:	ld		(FXPointer),hl		; ready for next time
			ld		e,a					; current frequency
			ld		d,a
			ld		hl,PlayOut			; return address
			push	hl
			ld		hl,(FXCode)
			defb	OP_JPHL

PlayOut:	xor		a
			out		(BEEPPORT),a
			;di
			ret

;****************************************
; NORMAL BEEP...
;****************************************

Beep:		ld		a,0x10
			out		(BEEPPORT),a
			ld		b,e
Beep0:		ld		a,r
			ret		m
			djnz	Beep0
			jr		Beep1

Beep1:		ld		a,0
			out		(BEEPPORT),a
			ld		b,d
Beep2:		ld		a,r
			ret		m
			djnz	Beep2
			jr		Beep

;****************************************
; PHASE BEEP...
;****************************************

Boop:		ld		a,0x10
			out		(BEEPPORT),a
			inc		e
			ld		b,e
Boop0:		ld		a,r
			ret		m
			djnz	Boop0
			jr		Boop1
Boop1:		ld		a,0
			out		(BEEPPORT),a
			dec		d
			ld		b,d
Boop2:		ld		a,r
			ret		m
			djnz	Boop2
			jr		Boop

;****************************************
; WHITE NOISE BEEP...
;****************************************

Hiss:		ld		hl,0				; rom pointer

Hisso:		ld		a,0x10
			out		(BEEPPORT),a
			ld		b,(hl)
			inc		hl
Hiss0:		ld		a,r
			ret		m
			djnz	Hiss0
			ld		a,0
			out		(BEEPPORT),a
			ld		b,d
			inc 	d
Hiss2:		ld		a,r
			ret		m
			djnz	Hiss2
			jr		Hisso



