
; VARIABLES DEL SONIDO DE SAUCER

;INTTABLE:	equ		0xfe00				; 257 byte vector table
;INTVECTOR:	equ		0xfdfd				; jp interrupts 3 bytes at this addrs

SpeedFlag:	defb	0					; timer flag every interrupt
FXNumber:	defb	0					; current sound fx number
FXPointer:	defw	0					; pointer to sound data
FXCode:		defw	0					; current beeper routine


BEEPPORT:	equ		0xfe				; beeper output port

OP_JPHL:	equ		0xe9				; op code for jp (hl)

FXOFF:		equ		0					; FX control codes
FXBEEP:		equ		1
FXBOOP:		equ		2
FXHISS:		equ		3
FXGAP:		equ		4

LASTFXCODE:	equ		FXGAP+1


;****************************************
; SOUND FX DATA...
;****************************************

BangFX1:	defb	FXHISS
			defb	10,50,100,200,20,60,150,250
			defb	FXOFF

BangFX2:	defb	FXHISS
			defb	250,240,230,220,150,140,130,120
			defb	FXOFF

BangFX3:	defb	FXHISS
			defb	10,50,100,50,100,50,30,10
			defb	FXOFF

BangFX4:	defb	FXHISS
			defb	200,250,100,150,200,100,250,150
			defb	FXOFF

FireFX1:	defb	FXBOOP,030,050,FXOFF	; saucer missiles
FireFX2:	defb	FXBOOP,010,100,FXOFF
FireFX3:	defb	FXBOOP,020,150,FXOFF
FireFX4:	defb	FXBOOP,040,250,FXOFF

LinkFX1:	defb	FXBOOP,030,020,FXOFF	; link to rover

;UnLinkFX1:	defb	/*FXHISS*/FXBOOP,230,FXOFF		; lift off from rover - mining ect
UnLinkFX1:	defb	FXBOOP,230,FXOFF		; lift off from rover - mining ect

;UnLinkFX2:	defb	/*FXBOOP*/FXHISS,220,FXOFF		; bubble burst
UnLinkFX2:	defb	FXHISS,220,FXOFF		; bubble burst

;CoinFX:		defb	FXBEEP,30,20,18,16,15,14,12,FXOFF

CoinFX:		defb	FXBEEP,30,30,20,20,30,30,20,20,16,16,20,20,16,16,15,15,16,16,15,15,14,14,12,12,11,10,FXOFF

TestFX:   defb  FXBOOP,10,11,12,12,14,14
          defb  FXBOOP,12,12,15,15,16,16
          defb  FXBOOP,15,15,20,20,30,30
          defb  FXBOOP,20,20,30,30,30,30
          defb  FXOFF

;TestFX:		defb	FXBOOP,200
;			defb	FXGAP,99,99,99,99
;			defb	FXBOOP,150
;			defb	FXGAP,99,99,99
;			defb	FXBOOP,200
;			defb	FXGAP,99,99
;			defb	FXBOOP,50
;			defb	FXGAP,99
;			defb	FXBOOP,100
;			defb	FXOFF

RKOnFX:		defb	FXHISS
			defb	10,20,30,40
			defb	FXGAP
			defb	99,99,99,99
			defb	FXHISS
			defb	10,40,60,80
			defb	FXGAP
			defb	99,99,99,99
			defb	FXHISS
			defb	10,80,120,160
			defb	FXGAP
			defb	99,99,99,99
			defb	FXHISS
			defb	10,160,240,255
			defb	FXOFF

RKClickFX:	defb	FXHISS
			defb	250,100,50,10
			defb	FXGAP
			defb	99,99,99,99
			defb	FXHISS
			defb	50,100,250
			defb	100,50,10
			defb	50,100,250
			defb	100,50,10
			defb	50,100,250
			defb	FXOFF


FXTEST:		equ		0x01
FXRKON:		equ		0x02				; rkeys
FXRKCLICK:	equ		0x03				; rkeys
FXBANG1:	equ		0x04
FXBANG2:	equ		0x05
FXBANG3:	equ		0x06
FXBANG4:	equ		0x07
FXFIRE1:	equ		0x08
FXFIRE2:	equ		0x09
FXFIRE3:	equ		0x0a
FXFIRE4:	equ		0x0b
FXLINK1:	equ		0x0c
FXUNLINK1:	equ		0x0d
FXUNLINK2:	equ		0x0e
FXCOIN:		equ		0x0f

FXRout:		defw	0					; 0
			defw	Beep				; 1 normal beep
			defw	Boop				; 2	phase beep
			defw	Hiss				; 3	white noise
			defw	WaitInt				; 4 no sound

FXTable:	defw	TestFX				; 0x01
			defw	RKOnFX				; 0x02
			defw	RKClickFX			; 0x03
			defw	BangFX1				; 0x04
			defw	BangFX2				; 0x05
			defw	BangFX3				; 0x06
			defw	BangFX4				; 0x07
			defw	FireFX1				; 0x08
			defw	FireFX2				; 0x09
			defw	FireFX3				; 0x0a
			defw	FireFX4				; 0x0b
			defw	LinkFX1				; 0x0c
			defw	UnLinkFX1			; 0x0d
			defw	UnLinkFX2			; 0x0e
			defw	CoinFX				; 0x0f

